Index: /branches/UKMO/dev_r8183_ICEMODEL_svn_removed/NEMOGCM/NEMO/LIM_SRC_3/icethd_zdf.F90
===================================================================
--- /branches/UKMO/dev_r8183_ICEMODEL_svn_removed/NEMOGCM/NEMO/LIM_SRC_3/icethd_zdf.F90	(revision 8751)
+++ /branches/UKMO/dev_r8183_ICEMODEL_svn_removed/NEMOGCM/NEMO/LIM_SRC_3/icethd_zdf.F90	(revision 8752)
@@ -34,8 +34,15 @@
    LOGICAL  ::   ln_cndi_U64      ! thermal conductivity: Untersteiner (1964)
    LOGICAL  ::   ln_cndi_P07      ! thermal conductivity: Pringle et al (2007)
-   REAL(wp) ::   rn_cnd_s         ! thermal conductivity of the snow [W/m/K]
    REAL(wp) ::   rn_kappa_i       ! coef. for the extinction of radiation Grenfell et al. (2006) [1/m]
-   LOGICAL  ::   ln_dqns_i        ! change non-solar surface flux with changing surface temperature (T) or not (F)
-
+   REAL(wp), PUBLIC ::   rn_cnd_s ! thermal conductivity of the snow [W/m/K]
+
+   INTEGER  ::   nice_zdf         ! Choice of the type of vertical heat diffusion formulation
+   !                                           ! associated indices:
+   INTEGER, PARAMETER ::   np_BL99    = 1      ! Bitz and Lipscomb (1999)
+
+   INTEGER , PARAMETER ::   np_zdf_jules_OFF    = 0   !   compute all temperatures from qsr and qns
+   INTEGER , PARAMETER ::   np_zdf_jules_SND    = 1   !   compute conductive heat flux and surface temperature from qsr and qns
+   INTEGER , PARAMETER ::   np_zdf_jules_RCV    = 2   !   compute snow and inner ice temperatures from qcnd
+   
    !!----------------------------------------------------------------------
    !! NEMO/ICE 4.0 , NEMO Consortium (2017)
@@ -45,10 +52,54 @@
 CONTAINS
 
-   SUBROUTINE ice_thd_zdf
+      SUBROUTINE ice_thd_zdf
+      
+      !!
       !!-------------------------------------------------------------------
       !!                ***  ROUTINE ice_thd_zdf  ***
       !! ** Purpose :
+      !!           This chooses between the appropriate routine for the 
+      !!           computation of vertical diffusion
+      !!
+      !!-------------------------------------------------------------------
+      !!
+   
+      SELECT CASE ( nice_zdf )      ! Choose the vertical heat diffusion solver
+      
+                                       !-------------      
+         CASE( np_BL99 )               ! BL99 solver
+                                       !-------------
+         
+            IF ( nice_jules == np_jules_OFF ) THEN   ! No Jules coupler     
+
+               CALL ice_thd_zdf_BL99 ( np_zdf_jules_OFF )
+                                       
+            ENDIF
+            
+            IF ( nice_jules == np_jules_EMULE ) THEN   ! Jules coupler is emulated
+            
+               CALL ice_thd_zdf_BL99 ( np_zdf_jules_SND )
+               CALL ice_thd_zdf_BL99 ( np_zdf_jules_RCV )
+                                                   
+            ENDIF
+
+            IF ( nice_jules == np_jules_ACTIVE ) THEN   ! Jules coupler is emulated
+            
+               CALL ice_thd_zdf_BL99 ( np_zdf_jules_RCV )
+                                                   
+            ENDIF
+            
+      END SELECT
+      
+   END SUBROUTINE ice_thd_zdf
+   
+   
+   
+   SUBROUTINE ice_thd_zdf_BL99(k_jules)
+      !!-------------------------------------------------------------------
+      !!                ***  ROUTINE ice_thd_zdf_BL99  ***
+      !! ** Purpose :
       !!           This routine determines the time evolution of snow and sea-ice 
-      !!           temperature profiles.
+      !!           temperature profiles, using the original Bitz and Lipscomb (1999) algorithm
+      !!
       !! ** Method  :
       !!           This is done by solving the heat equation diffusion with
@@ -83,4 +134,6 @@
       !!           total ice/snow thickness : h_i_1d, h_s_1d
       !!-------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   k_jules     ! Jules coupling (0=OFF, 1=RECEIVE, 2=SEND)
+      
       INTEGER ::   ji, jk         ! spatial loop index
       INTEGER ::   jm             ! current reference number of equation
@@ -101,5 +154,4 @@
       REAL(wp) ::   zdti_bnd  =  1.e-4_wp     ! maximal authorized error on temperature 
       REAL(wp) ::   ztmelt_i                  ! ice melting temperature
-      REAL(wp) ::   z1_hsu
       REAL(wp) ::   zdti_max                  ! current maximal error on temperature 
       REAL(wp) ::   zcpi                      ! Ice specific heat
@@ -111,10 +163,9 @@
       REAL(wp), DIMENSION(jpij)     ::   zh_i, z1_h_i ! ice layer thickness
       REAL(wp), DIMENSION(jpij)     ::   zh_s, z1_h_s ! snow layer thickness
-      REAL(wp), DIMENSION(jpij)     ::   zfsw        ! solar radiation absorbed at the surface
       REAL(wp), DIMENSION(jpij)     ::   zqns_ice_b  ! solar radiation absorbed at the surface
       REAL(wp), DIMENSION(jpij)     ::   zfnet       ! surface flux function
       REAL(wp), DIMENSION(jpij)     ::   zdqns_ice_b ! derivative of the surface flux function
-      REAL(wp), DIMENSION(jpij)     ::   zftrice     ! solar radiation transmitted through the ice
-      
+      
+      REAL(wp), DIMENSION(jpij       )     ::   ztsuold     ! Old surface temperature in the ice
       REAL(wp), DIMENSION(jpij,nlay_i)     ::   ztiold      ! Old temperature in the ice
       REAL(wp), DIMENSION(jpij,nlay_s)     ::   ztsold      ! Old temperature in the snow
@@ -136,4 +187,6 @@
       REAL(wp), DIMENSION(jpij)            ::   zq_ini      ! diag errors on heat
       REAL(wp), DIMENSION(jpij)            ::   zghe        ! G(he), th. conduct enhancement factor, mono-cat
+
+      REAL(wp) ::   zfr1, zfr2, zfrqsr_tr_i   ! dummy factor
       
       ! Mono-category
@@ -166,38 +219,43 @@
       ELSEWHERE                         ;   z1_h_s(1:npti) = 0._wp
       END WHERE
-      !
-      ! temperatures
-      ztsub  (1:npti)   = t_su_1d(1:npti)  ! temperature at the previous iteration
+
+      ! Store initial temperatures and non solar heat fluxes
+      IF ( k_jules == np_zdf_jules_OFF .OR. k_jules == np_zdf_jules_SND  ) THEN ! OFF or SND mode
+
+         ztsub  (1:npti)       =   t_su_1d(1:npti)                          ! surface temperature at iteration n-1
+         ztsuold(1:npti)       =   t_su_1d(1:npti)                          ! surface temperature initial value
+         zdqns_ice_b(1:npti)   =   dqns_ice_1d(1:npti)                      ! derivative of incoming nonsolar flux 
+         zqns_ice_b (1:npti)   =   qns_ice_1d(1:npti)                       ! store previous qns_ice_1d value
+
+         t_su_1d(1:npti)       =   MIN( t_su_1d(1:npti), rt0 - ztsu_err )   ! required to leave the choice between melting or not
+
+      ENDIF   
+
       ztsold (1:npti,:) = t_s_1d(1:npti,:)   ! Old snow temperature
       ztiold (1:npti,:) = t_i_1d(1:npti,:)   ! Old ice temperature
-      t_su_1d(1:npti)   = MIN( t_su_1d(1:npti), rt0 - ztsu_err )   ! necessary
-      !
+
       !-------------
       ! 2) Radiation
       !-------------
-      z1_hsu = 1._wp / 0.1_wp ! threshold for the computation of i0
-      DO ji = 1, npti
-         ! --- Computation of i0 --- !
-         ! i0 describes the fraction of solar radiation which does not contribute
-         ! to the surface energy budget but rather penetrates inside the ice.
-         ! We assume that no radiation is transmitted through the snow
-         ! If there is no no snow
-         ! zfsw    = (1-i0).qsr_ice   is absorbed at the surface 
-         ! zftrice = io.qsr_ice       is below the surface 
-         ! ftr_ice = io.qsr_ice.exp(-k(h_i)) transmitted below the ice 
-         ! fr1_i0_1d = i0 for a thin ice cover, fr1_i0_2d = i0 for a thick ice cover
-         zfac = MAX( 0._wp , 1._wp - ( h_i_1d(ji) * z1_hsu ) )     
-         i0(ji) = ( 1._wp - isnow(ji) ) * ( fr1_i0_1d(ji) + zfac * fr2_i0_1d(ji) )
-
-         ! --- Solar radiation absorbed / transmitted at the surface --- !
-         !     Derivative of the non solar flux
-         zfsw   (ji)     =  qsr_ice_1d(ji) * ( 1 - i0(ji) )   ! Shortwave radiation absorbed at surface
-         zftrice(ji)     =  qsr_ice_1d(ji) *       i0(ji)     ! Solar radiation transmitted below the surface layer
-         zdqns_ice_b(ji) = dqns_ice_1d(ji)                    ! derivative of incoming nonsolar flux 
-         zqns_ice_b (ji) =  qns_ice_1d(ji)                    ! store previous qns_ice_1d value
-      END DO
-
       ! --- Transmission/absorption of solar radiation in the ice --- !
-      zradtr_s(1:npti,0) = zftrice(1:npti)
+!     zfr1 = ( 0.18 * ( 1.0 - 0.81 ) + 0.35 * 0.81 )            !   standard value
+!     zfr2 = ( 0.82 * ( 1.0 - 0.81 ) + 0.65 * 0.81 )            !   zfr2 such that zfr1 + zfr2 to equal 1
+
+!     DO ji = 1, npti
+
+!        zfac = MAX( 0._wp , 1._wp - ( h_i_1d(ji) * 10._wp ) )     
+
+!              zfrqsr_tr_i = zfr1 + zfac * zfr2                         !   below 10 cm, linearly increase zfrqsr_tr_i until 1 at zero thickness
+!              IF ( h_s_1d(ji) >= 0.0_wp )   zfrqsr_tr_i = 0._wp     !   snow fully opaque
+
+!              qsr_ice_tr_1d(ji) = zfrqsr_tr_i * qsr_ice_1d(ji)   !   transmitted solar radiation 
+
+!              zfsw(ji) = qsr_ice_1d(ji) - qsr_ice_tr_1d(ji)
+!              zftrice(ji) = qsr_ice_tr_1d(ji)
+!              i0(ji) = zfrqsr_tr_i
+
+!     END DO
+
+      zradtr_s(1:npti,0) = qsr_ice_tr_1d(1:npti)
       DO jk = 1, nlay_s
          DO ji = 1, npti
@@ -209,5 +267,5 @@
       END DO
          
-      zradtr_i(1:npti,0) = zradtr_s(1:npti,nlay_s) * isnow(1:npti) + zftrice(1:npti) * ( 1._wp - isnow(1:npti) )
+      zradtr_i(1:npti,0) = zradtr_s(1:npti,nlay_s) * isnow(1:npti) + qsr_ice_tr_1d(1:npti) * ( 1._wp - isnow(1:npti) )
       DO jk = 1, nlay_i 
          DO ji = 1, npti
@@ -330,34 +388,50 @@
             END DO
          END DO
-         !
-         !----------------------------
-         ! 6) surface flux computation
-         !----------------------------
-         IF ( ln_dqns_i ) THEN 
-            DO ji = 1, npti
-               ! update of the non solar flux according to the update in T_su
+         
+         !
+         !----------------------------------------!
+         !                                        !
+         !       JULES IF (OFF or SND MODE)       !
+         !                                        !
+         !----------------------------------------!
+         !
+         
+         IF ( k_jules == np_zdf_jules_OFF .OR. k_jules == np_zdf_jules_SND  ) THEN ! OFF or SND mode
+         
+            !
+            ! In OFF mode the original BL99 temperature computation is used
+            ! (with qsr_ice, qns_ice and dqns_ice as inputs)
+            !
+            ! In SND mode, the computation is required to compute the conduction fluxes
+            !
+         
+            !----------------------------
+            ! 6) surface flux computation
+            !----------------------------
+
+            DO ji = 1, npti
+            ! update of the non solar flux according to the update in T_su
                qns_ice_1d(ji) = qns_ice_1d(ji) + dqns_ice_1d(ji) * ( t_su_1d(ji) - ztsub(ji) )
             END DO
-         ENDIF
-
-         DO ji = 1, npti
-            zfnet(ji) = zfsw(ji) + qns_ice_1d(ji) ! incoming = net absorbed solar radiation + non solar total flux (LWup, LWdw, SH, LH)
-         END DO
-         !
-         !----------------------------
-         ! 7) tridiagonal system terms
-         !----------------------------
-         !!layer denotes the number of the layer in the snow or in the ice
-         !!jm denotes the reference number of the equation in the tridiagonal
-         !!system, terms of tridiagonal system are indexed as following :
-         !!1 is subdiagonal term, 2 is diagonal and 3 is superdiagonal one
-
-         !!ice interior terms (top equation has the same form as the others)
-         ztrid   (1:npti,:,:) = 0._wp
-         zindterm(1:npti,:)   = 0._wp
-         zindtbis(1:npti,:)   = 0._wp
-         zdiagbis(1:npti,:)   = 0._wp
-
-         DO jm = nlay_s + 2, nlay_s + nlay_i 
+
+            DO ji = 1, npti
+               zfnet(ji) = qsr_ice_1d(ji) - qsr_ice_tr_1d(ji) + qns_ice_1d(ji) ! net heat flux = net solar - transmitted solar + non solar
+            END DO
+            !
+            !----------------------------
+            ! 7) tridiagonal system terms
+            !----------------------------
+            !!layer denotes the number of the layer in the snow or in the ice
+            !!jm denotes the reference number of the equation in the tridiagonal
+            !!system, terms of tridiagonal system are indexed as following :
+            !!1 is subdiagonal term, 2 is diagonal and 3 is superdiagonal one
+
+            !!ice interior terms (top equation has the same form as the others)
+            ztrid   (1:npti,:,:) = 0._wp
+            zindterm(1:npti,:)   = 0._wp
+            zindtbis(1:npti,:)   = 0._wp
+            zdiagbis(1:npti,:)   = 0._wp
+
+            DO jm = nlay_s + 2, nlay_s + nlay_i 
             DO ji = 1, npti
                jk = jm - nlay_s - 1
@@ -367,8 +441,8 @@
                zindterm(ji,jm) = ztiold(ji,jk) + zeta_i(ji,jk) * zradab_i(ji,jk)
             END DO
-         ENDDO
-
-         jm =  nlay_s + nlay_i + 1
-         DO ji = 1, npti
+            ENDDO
+
+            jm =  nlay_s + nlay_i + 1
+            DO ji = 1, npti
             !!ice bottom term
             ztrid(ji,jm,1)  = - zeta_i(ji,nlay_i)*zkappa_i(ji,nlay_i-1)   
@@ -377,54 +451,54 @@
             zindterm(ji,jm) = ztiold(ji,nlay_i) + zeta_i(ji,nlay_i) *  &
                &            ( zradab_i(ji,nlay_i) + zkappa_i(ji,nlay_i) * zg1 *  t_bo_1d(ji) ) 
-         ENDDO
-
-
-         DO ji = 1, npti
+            ENDDO
+
+
+            DO ji = 1, npti
             !                               !---------------------!
-            IF ( h_s_1d(ji) > 0.0 ) THEN   !  snow-covered cells !
+            IF ( h_s_1d(ji) > 0.0 ) THEN    !  snow-covered cells !
                !                            !---------------------!
                ! snow interior terms (bottom equation has the same form as the others)
                DO jm = 3, nlay_s + 1
-                  jk = jm - 1
-                  ztrid(ji,jm,1)  = - zeta_s(ji,jk) * zkappa_s(ji,jk-1)
-                  ztrid(ji,jm,2)  = 1.0 + zeta_s(ji,jk) * ( zkappa_s(ji,jk-1) + zkappa_s(ji,jk) )
-                  ztrid(ji,jm,3)  = - zeta_s(ji,jk)*zkappa_s(ji,jk)
-                  zindterm(ji,jm) = ztsold(ji,jk) + zeta_s(ji,jk) * zradab_s(ji,jk)
+               jk = jm - 1
+               ztrid(ji,jm,1)  = - zeta_s(ji,jk) * zkappa_s(ji,jk-1)
+               ztrid(ji,jm,2)  = 1.0 + zeta_s(ji,jk) * ( zkappa_s(ji,jk-1) + zkappa_s(ji,jk) )
+               ztrid(ji,jm,3)  = - zeta_s(ji,jk)*zkappa_s(ji,jk)
+               zindterm(ji,jm) = ztsold(ji,jk) + zeta_s(ji,jk) * zradab_s(ji,jk)
                END DO
 
                ! case of only one layer in the ice (ice equation is altered)
                IF ( nlay_i == 1 ) THEN
-                  ztrid(ji,nlay_s+2,3)  = 0.0
-                  zindterm(ji,nlay_s+2) = zindterm(ji,nlay_s+2) + zkappa_i(ji,1) * t_bo_1d(ji) 
+               ztrid(ji,nlay_s+2,3)  = 0.0
+               zindterm(ji,nlay_s+2) = zindterm(ji,nlay_s+2) + zkappa_i(ji,1) * t_bo_1d(ji) 
                ENDIF
 
                IF ( t_su_1d(ji) < rt0 ) THEN   !--  case 1 : no surface melting
 
-                  jm_min(ji) = 1
-                  jm_max(ji) = nlay_i + nlay_s + 1
-
-                  ! surface equation
-                  ztrid(ji,1,1)  = 0.0
-                  ztrid(ji,1,2)  = zdqns_ice_b(ji) - zg1s * zkappa_s(ji,0)
-                  ztrid(ji,1,3)  = zg1s * zkappa_s(ji,0)
-                  zindterm(ji,1) = zdqns_ice_b(ji) * t_su_1d(ji) - zfnet(ji)
-
-                  ! first layer of snow equation
-                  ztrid(ji,2,1)  = - zkappa_s(ji,0) * zg1s * zeta_s(ji,1)
-                  ztrid(ji,2,2)  = 1.0 + zeta_s(ji,1) * ( zkappa_s(ji,1) + zkappa_s(ji,0) * zg1s )
-                  ztrid(ji,2,3)  = - zeta_s(ji,1)* zkappa_s(ji,1)
-                  zindterm(ji,2) = ztsold(ji,1) + zeta_s(ji,1) * zradab_s(ji,1)
+               jm_min(ji) = 1
+               jm_max(ji) = nlay_i + nlay_s + 1
+
+               ! surface equation
+               ztrid(ji,1,1)  = 0.0
+               ztrid(ji,1,2)  = zdqns_ice_b(ji) - zg1s * zkappa_s(ji,0)
+               ztrid(ji,1,3)  = zg1s * zkappa_s(ji,0)
+               zindterm(ji,1) = zdqns_ice_b(ji) * t_su_1d(ji) - zfnet(ji)
+
+               ! first layer of snow equation
+               ztrid(ji,2,1)  = - zkappa_s(ji,0) * zg1s * zeta_s(ji,1)
+               ztrid(ji,2,2)  = 1.0 + zeta_s(ji,1) * ( zkappa_s(ji,1) + zkappa_s(ji,0) * zg1s )
+               ztrid(ji,2,3)  = - zeta_s(ji,1)* zkappa_s(ji,1)
+               zindterm(ji,2) = ztsold(ji,1) + zeta_s(ji,1) * zradab_s(ji,1)
 
                ELSE                            !--  case 2 : surface is melting
-                  !
-                  jm_min(ji) = 2
-                  jm_max(ji) = nlay_i + nlay_s + 1
-
-                  ! first layer of snow equation
-                  ztrid(ji,2,1)  = 0.0
-                  ztrid(ji,2,2)  = 1.0 + zeta_s(ji,1) * ( zkappa_s(ji,1) + zkappa_s(ji,0) * zg1s )
-                  ztrid(ji,2,3)  = - zeta_s(ji,1)*zkappa_s(ji,1) 
-                  zindterm(ji,2) = ztsold(ji,1) + zeta_s(ji,1) *  &
-                     &           ( zradab_s(ji,1) + zkappa_s(ji,0) * zg1s * t_su_1d(ji) ) 
+               !
+               jm_min(ji) = 2
+               jm_max(ji) = nlay_i + nlay_s + 1
+
+               ! first layer of snow equation
+               ztrid(ji,2,1)  = 0.0
+               ztrid(ji,2,2)  = 1.0 + zeta_s(ji,1) * ( zkappa_s(ji,1) + zkappa_s(ji,0) * zg1s )
+               ztrid(ji,2,3)  = - zeta_s(ji,1)*zkappa_s(ji,1) 
+               zindterm(ji,2) = ztsold(ji,1) + zeta_s(ji,1) *  &
+               &           ( zradab_s(ji,1) + zkappa_s(ji,0) * zg1s * t_su_1d(ji) ) 
                ENDIF
             !                               !---------------------!
@@ -433,52 +507,52 @@
                !
                IF ( t_su_1d(ji) < rt0 ) THEN   !--  case 1 : no surface melting
-                  !
-                  jm_min(ji) = nlay_s + 1
-                  jm_max(ji) = nlay_i + nlay_s + 1
-
-                  ! surface equation	
-                  ztrid(ji,jm_min(ji),1)  = 0.0
-                  ztrid(ji,jm_min(ji),2)  = zdqns_ice_b(ji) - zkappa_i(ji,0)*zg1    
-                  ztrid(ji,jm_min(ji),3)  = zkappa_i(ji,0)*zg1
-                  zindterm(ji,jm_min(ji)) = zdqns_ice_b(ji)*t_su_1d(ji) - zfnet(ji)
-
-                  ! first layer of ice equation
-                  ztrid(ji,jm_min(ji)+1,1)  = - zkappa_i(ji,0) * zg1 * zeta_i(ji,1)
-                  ztrid(ji,jm_min(ji)+1,2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,1) + zkappa_i(ji,0) * zg1 )
-                  ztrid(ji,jm_min(ji)+1,3)  = - zeta_i(ji,1) * zkappa_i(ji,1)  
-                  zindterm(ji,jm_min(ji)+1) = ztiold(ji,1) + zeta_i(ji,1) * zradab_i(ji,1)  
-
-                  ! case of only one layer in the ice (surface & ice equations are altered)
-                  IF ( nlay_i == 1 ) THEN
-                     ztrid(ji,jm_min(ji),1)    = 0.0
-                     ztrid(ji,jm_min(ji),2)    = zdqns_ice_b(ji) - zkappa_i(ji,0) * 2.0
-                     ztrid(ji,jm_min(ji),3)    = zkappa_i(ji,0) * 2.0
-                     ztrid(ji,jm_min(ji)+1,1)  = -zkappa_i(ji,0) * 2.0 * zeta_i(ji,1)
-                     ztrid(ji,jm_min(ji)+1,2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,0) * 2.0 + zkappa_i(ji,1) )
-                     ztrid(ji,jm_min(ji)+1,3)  = 0.0
-                     zindterm(ji,jm_min(ji)+1) = ztiold(ji,1) + zeta_i(ji,1) *  &
-                        &                      ( zradab_i(ji,1) + zkappa_i(ji,1) * t_bo_1d(ji) )
-                  ENDIF
+               !
+               jm_min(ji) = nlay_s + 1
+               jm_max(ji) = nlay_i + nlay_s + 1
+
+               ! surface equation	
+               ztrid(ji,jm_min(ji),1)  = 0.0
+               ztrid(ji,jm_min(ji),2)  = zdqns_ice_b(ji) - zkappa_i(ji,0)*zg1    
+               ztrid(ji,jm_min(ji),3)  = zkappa_i(ji,0)*zg1
+               zindterm(ji,jm_min(ji)) = zdqns_ice_b(ji)*t_su_1d(ji) - zfnet(ji)
+
+               ! first layer of ice equation
+               ztrid(ji,jm_min(ji)+1,1)  = - zkappa_i(ji,0) * zg1 * zeta_i(ji,1)
+               ztrid(ji,jm_min(ji)+1,2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,1) + zkappa_i(ji,0) * zg1 )
+               ztrid(ji,jm_min(ji)+1,3)  = - zeta_i(ji,1) * zkappa_i(ji,1)  
+               zindterm(ji,jm_min(ji)+1) = ztiold(ji,1) + zeta_i(ji,1) * zradab_i(ji,1)  
+
+               ! case of only one layer in the ice (surface & ice equations are altered)
+               IF ( nlay_i == 1 ) THEN
+               ztrid(ji,jm_min(ji),1)    = 0.0
+               ztrid(ji,jm_min(ji),2)    = zdqns_ice_b(ji) - zkappa_i(ji,0) * 2.0
+               ztrid(ji,jm_min(ji),3)    = zkappa_i(ji,0) * 2.0
+               ztrid(ji,jm_min(ji)+1,1)  = -zkappa_i(ji,0) * 2.0 * zeta_i(ji,1)
+               ztrid(ji,jm_min(ji)+1,2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,0) * 2.0 + zkappa_i(ji,1) )
+               ztrid(ji,jm_min(ji)+1,3)  = 0.0
+               zindterm(ji,jm_min(ji)+1) = ztiold(ji,1) + zeta_i(ji,1) *  &
+               &                      ( zradab_i(ji,1) + zkappa_i(ji,1) * t_bo_1d(ji) )
+               ENDIF
 
                ELSE                            !--  case 2 : surface is melting
 
-                  jm_min(ji)    =  nlay_s + 2
-                  jm_max(ji)    =  nlay_i + nlay_s + 1
-
-                  ! first layer of ice equation
-                  ztrid(ji,jm_min(ji),1)  = 0.0
-                  ztrid(ji,jm_min(ji),2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,1) + zkappa_i(ji,0) * zg1 )  
-                  ztrid(ji,jm_min(ji),3)  = - zeta_i(ji,1) * zkappa_i(ji,1)
-                  zindterm(ji,jm_min(ji)) = ztiold(ji,1) + zeta_i(ji,1) *  &
-                     &                    ( zradab_i(ji,1) + zkappa_i(ji,0) * zg1 * t_su_1d(ji) ) 
-
-                  ! case of only one layer in the ice (surface & ice equations are altered)
-                  IF ( nlay_i == 1 ) THEN
-                     ztrid(ji,jm_min(ji),1)  = 0.0
-                     ztrid(ji,jm_min(ji),2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,0) * 2.0 + zkappa_i(ji,1) )
-                     ztrid(ji,jm_min(ji),3)  = 0.0
-                     zindterm(ji,jm_min(ji)) = ztiold(ji,1) + zeta_i(ji,1) * ( zradab_i(ji,1) + zkappa_i(ji,1) * t_bo_1d(ji) )  &
-                        &                    + t_su_1d(ji) * zeta_i(ji,1) * zkappa_i(ji,0) * 2.0
-                  ENDIF
+               jm_min(ji)    =  nlay_s + 2
+               jm_max(ji)    =  nlay_i + nlay_s + 1
+
+               ! first layer of ice equation
+               ztrid(ji,jm_min(ji),1)  = 0.0
+               ztrid(ji,jm_min(ji),2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,1) + zkappa_i(ji,0) * zg1 )  
+               ztrid(ji,jm_min(ji),3)  = - zeta_i(ji,1) * zkappa_i(ji,1)
+               zindterm(ji,jm_min(ji)) = ztiold(ji,1) + zeta_i(ji,1) *  &
+               &                    ( zradab_i(ji,1) + zkappa_i(ji,0) * zg1 * t_su_1d(ji) ) 
+
+               ! case of only one layer in the ice (surface & ice equations are altered)
+               IF ( nlay_i == 1 ) THEN
+               ztrid(ji,jm_min(ji),1)  = 0.0
+               ztrid(ji,jm_min(ji),2)  = 1.0 + zeta_i(ji,1) * ( zkappa_i(ji,0) * 2.0 + zkappa_i(ji,1) )
+               ztrid(ji,jm_min(ji),3)  = 0.0
+               zindterm(ji,jm_min(ji)) = ztiold(ji,1) + zeta_i(ji,1) * ( zradab_i(ji,1) + zkappa_i(ji,1) * t_bo_1d(ji) )  &
+               &                    + t_su_1d(ji) * zeta_i(ji,1) * zkappa_i(ji,0) * 2.0
+               ENDIF
 
                ENDIF
@@ -488,19 +562,19 @@
             zdiagbis(ji,jm_min(ji)) = ztrid(ji,jm_min(ji),2)
             !
-         END DO
-         !
-         !------------------------------
-         ! 8) tridiagonal system solving
-         !------------------------------
-         ! Solve the tridiagonal system with Gauss elimination method.
-         ! Thomas algorithm, from Computational fluid Dynamics, J.D. ANDERSON, McGraw-Hill 1984
-         jm_maxt = 0
-         jm_mint = nlay_i+5
-         DO ji = 1, npti
+            END DO
+            !
+            !------------------------------
+            ! 8) tridiagonal system solving
+            !------------------------------
+            ! Solve the tridiagonal system with Gauss elimination method.
+            ! Thomas algorithm, from Computational fluid Dynamics, J.D. ANDERSON, McGraw-Hill 1984
+            jm_maxt = 0
+            jm_mint = nlay_i+5
+            DO ji = 1, npti
             jm_mint = MIN(jm_min(ji),jm_mint)
             jm_maxt = MAX(jm_max(ji),jm_maxt)
-         END DO
-
-         DO jk = jm_mint+1, jm_maxt
+            END DO
+
+            DO jk = jm_mint+1, jm_maxt
             DO ji = 1, npti
                jm = min(max(jm_min(ji)+1,jk),jm_max(ji))
@@ -508,23 +582,23 @@
                zindtbis(ji,jm) = zindterm(ji,jm) - ztrid(ji,jm,1) * zindtbis(ji,jm-1) / zdiagbis(ji,jm-1)
             END DO
-         END DO
-
-         DO ji = 1, npti
+            END DO
+
+            DO ji = 1, npti
             ! ice temperatures
             t_i_1d(ji,nlay_i) = zindtbis(ji,jm_max(ji)) / zdiagbis(ji,jm_max(ji))
-         END DO
-
-         DO jm = nlay_i + nlay_s, nlay_s + 2, -1
+            END DO
+
+            DO jm = nlay_i + nlay_s, nlay_s + 2, -1
             DO ji = 1, npti
                jk    =  jm - nlay_s - 1
                t_i_1d(ji,jk) = ( zindtbis(ji,jm) - ztrid(ji,jm,3) * t_i_1d(ji,jk+1) ) / zdiagbis(ji,jm)
             END DO
-         END DO
-
-         DO ji = 1, npti
+            END DO
+
+            DO ji = 1, npti
             ! snow temperatures      
             IF( h_s_1d(ji) > 0._wp ) THEN
                t_s_1d(ji,nlay_s) = ( zindtbis(ji,nlay_s+1) - ztrid(ji,nlay_s+1,3) * t_i_1d(ji,1) )  &
-                  &                / zdiagbis(ji,nlay_s+1)
+               &                / zdiagbis(ji,nlay_s+1)
             ENDIF
             ! surface temperature
@@ -532,27 +606,27 @@
             IF( t_su_1d(ji) < rt0 ) THEN
                t_su_1d(ji) = ( zindtbis(ji,jm_min(ji)) - ztrid(ji,jm_min(ji),3) *  &
-                  &          ( isnow(ji) * t_s_1d(ji,1) + ( 1._wp - isnow(ji) ) * t_i_1d(ji,1) ) ) / zdiagbis(ji,jm_min(ji))
-            ENDIF
-         END DO
-         !
-         !--------------------------------------------------------------
-         ! 9) Has the scheme converged ?, end of the iterative procedure
-         !--------------------------------------------------------------
-         ! check that nowhere it has started to melt
-         ! zdti_max is a measure of error, it has to be under zdti_bnd
-         zdti_max = 0._wp
-         DO ji = 1, npti
+               &          ( isnow(ji) * t_s_1d(ji,1) + ( 1._wp - isnow(ji) ) * t_i_1d(ji,1) ) ) / zdiagbis(ji,jm_min(ji))
+            ENDIF
+            END DO
+            !
+            !--------------------------------------------------------------
+            ! 9) Has the scheme converged ?, end of the iterative procedure
+            !--------------------------------------------------------------
+            ! check that nowhere it has started to melt
+            ! zdti_max is a measure of error, it has to be under zdti_bnd
+            zdti_max = 0._wp
+            DO ji = 1, npti
             t_su_1d(ji) = MAX( MIN( t_su_1d(ji) , rt0 ) , rt0 - 100._wp )
             zdti_max = MAX( zdti_max, ABS( t_su_1d(ji) - ztsub(ji) ) )     
-         END DO
-
-         DO jk  =  1, nlay_s
+            END DO
+
+            DO jk  =  1, nlay_s
             DO ji = 1, npti
                t_s_1d(ji,jk) = MAX( MIN( t_s_1d(ji,jk), rt0 ), rt0 - 100._wp )
                zdti_max = MAX( zdti_max, ABS( t_s_1d(ji,jk) - ztsb(ji,jk) ) )
             END DO
-         END DO
-
-         DO jk  =  1, nlay_i
+            END DO
+
+            DO jk  =  1, nlay_i
             DO ji = 1, npti
                ztmelt_i      = -tmut * sz_i_1d(ji,jk) + rt0 
